// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from automotive_navigation_msgs:msg/LaneBoundary.idl
// generated code does not contain a copyright notice
#include "automotive_navigation_msgs/msg/detail/lane_boundary__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "automotive_navigation_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "automotive_navigation_msgs/msg/detail/lane_boundary__struct.h"
#include "automotive_navigation_msgs/msg/detail/lane_boundary__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "geometry_msgs/msg/detail/point__functions.h"  // line

// forward declare type support functions
ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_automotive_navigation_msgs
size_t get_serialized_size_geometry_msgs__msg__Point(
  const void * untyped_ros_message,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_automotive_navigation_msgs
size_t max_serialized_size_geometry_msgs__msg__Point(
  bool & full_bounded,
  size_t current_alignment);

ROSIDL_TYPESUPPORT_FASTRTPS_C_IMPORT_automotive_navigation_msgs
const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Point)();


using _LaneBoundary__ros_msg_type = automotive_navigation_msgs__msg__LaneBoundary;

static bool _LaneBoundary__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _LaneBoundary__ros_msg_type * ros_message = static_cast<const _LaneBoundary__ros_msg_type *>(untyped_ros_message);
  // Field name: style
  {
    cdr << ros_message->style;
  }

  // Field name: color
  {
    cdr << ros_message->color;
  }

  // Field name: line
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Point
      )()->data);
    size_t size = ros_message->line.size;
    auto array_ptr = ros_message->line.data;
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; ++i) {
      if (!callbacks->cdr_serialize(
          &array_ptr[i], cdr))
      {
        return false;
      }
    }
  }

  return true;
}

static bool _LaneBoundary__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _LaneBoundary__ros_msg_type * ros_message = static_cast<_LaneBoundary__ros_msg_type *>(untyped_ros_message);
  // Field name: style
  {
    cdr >> ros_message->style;
  }

  // Field name: color
  {
    cdr >> ros_message->color;
  }

  // Field name: line
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, geometry_msgs, msg, Point
      )()->data);
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->line.data) {
      geometry_msgs__msg__Point__Sequence__fini(&ros_message->line);
    }
    if (!geometry_msgs__msg__Point__Sequence__init(&ros_message->line, size)) {
      fprintf(stderr, "failed to create array for field 'line'");
      return false;
    }
    auto array_ptr = ros_message->line.data;
    for (size_t i = 0; i < size; ++i) {
      if (!callbacks->cdr_deserialize(
          cdr, &array_ptr[i]))
      {
        return false;
      }
    }
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_automotive_navigation_msgs
size_t get_serialized_size_automotive_navigation_msgs__msg__LaneBoundary(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _LaneBoundary__ros_msg_type * ros_message = static_cast<const _LaneBoundary__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name style
  {
    size_t item_size = sizeof(ros_message->style);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name color
  {
    size_t item_size = sizeof(ros_message->color);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name line
  {
    size_t array_size = ros_message->line.size;
    auto array_ptr = ros_message->line.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += get_serialized_size_geometry_msgs__msg__Point(
        &array_ptr[index], current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static uint32_t _LaneBoundary__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_automotive_navigation_msgs__msg__LaneBoundary(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_automotive_navigation_msgs
size_t max_serialized_size_automotive_navigation_msgs__msg__LaneBoundary(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;

  // member: style
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }
  // member: color
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }
  // member: line
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        max_serialized_size_geometry_msgs__msg__Point(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static size_t _LaneBoundary__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_automotive_navigation_msgs__msg__LaneBoundary(
    full_bounded, 0);
}


static message_type_support_callbacks_t __callbacks_LaneBoundary = {
  "automotive_navigation_msgs::msg",
  "LaneBoundary",
  _LaneBoundary__cdr_serialize,
  _LaneBoundary__cdr_deserialize,
  _LaneBoundary__get_serialized_size,
  _LaneBoundary__max_serialized_size
};

static rosidl_message_type_support_t _LaneBoundary__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_LaneBoundary,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, automotive_navigation_msgs, msg, LaneBoundary)() {
  return &_LaneBoundary__type_support;
}

#if defined(__cplusplus)
}
#endif
