// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from automotive_navigation_msgs:msg/PointOfInterestResponse.idl
// generated code does not contain a copyright notice
#include "automotive_navigation_msgs/msg/detail/point_of_interest_response__rosidl_typesupport_fastrtps_cpp.hpp"
#include "automotive_navigation_msgs/msg/detail/point_of_interest_response__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace std_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const std_msgs::msg::Header &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  std_msgs::msg::Header &);
size_t get_serialized_size(
  const std_msgs::msg::Header &,
  size_t current_alignment);
size_t
max_serialized_size_Header(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace std_msgs

namespace automotive_navigation_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const automotive_navigation_msgs::msg::PointOfInterestStatus &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  automotive_navigation_msgs::msg::PointOfInterestStatus &);
size_t get_serialized_size(
  const automotive_navigation_msgs::msg::PointOfInterestStatus &,
  size_t current_alignment);
size_t
max_serialized_size_PointOfInterestStatus(
  bool & full_bounded,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace automotive_navigation_msgs


namespace automotive_navigation_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_navigation_msgs
cdr_serialize(
  const automotive_navigation_msgs::msg::PointOfInterestResponse & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.header,
    cdr);
  // Member: name
  cdr << ros_message.name;
  // Member: module_name
  cdr << ros_message.module_name;
  // Member: request_id
  cdr << ros_message.request_id;
  // Member: update_num
  cdr << ros_message.update_num;
  // Member: point_statuses
  {
    size_t size = ros_message.point_statuses.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      automotive_navigation_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.point_statuses[i],
        cdr);
    }
  }
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_navigation_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  automotive_navigation_msgs::msg::PointOfInterestResponse & ros_message)
{
  // Member: header
  std_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.header);

  // Member: name
  cdr >> ros_message.name;

  // Member: module_name
  cdr >> ros_message.module_name;

  // Member: request_id
  cdr >> ros_message.request_id;

  // Member: update_num
  cdr >> ros_message.update_num;

  // Member: point_statuses
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.point_statuses.resize(size);
    for (size_t i = 0; i < size; i++) {
      automotive_navigation_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.point_statuses[i]);
    }
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_navigation_msgs
get_serialized_size(
  const automotive_navigation_msgs::msg::PointOfInterestResponse & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: header

  current_alignment +=
    std_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.header, current_alignment);
  // Member: name
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.name.size() + 1);
  // Member: module_name
  current_alignment += padding +
    eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
    (ros_message.module_name.size() + 1);
  // Member: request_id
  {
    size_t item_size = sizeof(ros_message.request_id);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: update_num
  {
    size_t item_size = sizeof(ros_message.update_num);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: point_statuses
  {
    size_t array_size = ros_message.point_statuses.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        automotive_navigation_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.point_statuses[index], current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_automotive_navigation_msgs
max_serialized_size_PointOfInterestResponse(
  bool & full_bounded,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;
  (void)full_bounded;


  // Member: header
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        std_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_Header(
        full_bounded, current_alignment);
    }
  }

  // Member: name
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: module_name
  {
    size_t array_size = 1;

    full_bounded = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: request_id
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  // Member: update_num
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint16_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint16_t));
  }

  // Member: point_statuses
  {
    size_t array_size = 0;
    full_bounded = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        automotive_navigation_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_PointOfInterestStatus(
        full_bounded, current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

static bool _PointOfInterestResponse__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const automotive_navigation_msgs::msg::PointOfInterestResponse *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _PointOfInterestResponse__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<automotive_navigation_msgs::msg::PointOfInterestResponse *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _PointOfInterestResponse__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const automotive_navigation_msgs::msg::PointOfInterestResponse *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _PointOfInterestResponse__max_serialized_size(bool & full_bounded)
{
  return max_serialized_size_PointOfInterestResponse(full_bounded, 0);
}

static message_type_support_callbacks_t _PointOfInterestResponse__callbacks = {
  "automotive_navigation_msgs::msg",
  "PointOfInterestResponse",
  _PointOfInterestResponse__cdr_serialize,
  _PointOfInterestResponse__cdr_deserialize,
  _PointOfInterestResponse__get_serialized_size,
  _PointOfInterestResponse__max_serialized_size
};

static rosidl_message_type_support_t _PointOfInterestResponse__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_PointOfInterestResponse__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace automotive_navigation_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_automotive_navigation_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<automotive_navigation_msgs::msg::PointOfInterestResponse>()
{
  return &automotive_navigation_msgs::msg::typesupport_fastrtps_cpp::_PointOfInterestResponse__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, automotive_navigation_msgs, msg, PointOfInterestResponse)() {
  return &automotive_navigation_msgs::msg::typesupport_fastrtps_cpp::_PointOfInterestResponse__handle;
}

#ifdef __cplusplus
}
#endif
